import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;


public class BallView{
    private Color color = Color.GREEN;
    private Ellipse2D.Double shape = null;
    private Ball ball;
    private final double radius;

    public BallView (Ball b, double r){
        ball=b;
        radius = r;
        Vector2D pos = b.getPosition();
        shape = new Ellipse2D.Double(pos.getX()-radius, pos.getY()-radius, 2*radius, 2*radius);
    }
    
    public void setColor(Color color){
        this.color=color;
    }
    
    void paint(Graphics2D g) {
        Vector2D pos = ball.getPosition();
        shape.setFrame(pos.getX()-radius, pos.getY()-radius, 2*radius, 2*radius);
        g.setColor(color);
        g.fill(shape);
    }
}