import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.RoundRectangle2D;


public class OscillatorView {
    private Color color1 = Color.BLACK;
    private Color color2 = Color.RED;
    private RoundRectangle2D.Double shape = null;
    private Ellipse2D.Double shape2=null;
    private final double radius;
    private Oscillator oscillator;
    
    public OscillatorView(Oscillator os,double r){
        oscillator=os;
        radius=r;
        Vector2D pos = os.getPosition();
        shape= new RoundRectangle2D.Double(pos.getX()-radius, pos.getY()-radius, 2*radius, 2*radius, 0.05, 0.05);
        shape2=new Ellipse2D.Double(pos.getX()-radius/2, pos.getY()-radius/2, radius, radius);
    }
    
    void paint(Graphics2D g) {
      Vector2D pos = oscillator.getPosition();
      shape.setFrame(pos.getX()-radius, pos.getY()-radius, 2*radius, 2*radius);
      shape2.setFrame(pos.getX()-radius/2, pos.getY()-radius/2, radius, radius);
      g.setColor(color1);
      g.fill(shape);
      g.setColor(color2);
      g.fill(shape2);
   }
}
