import java.awt.Color;
import javax.swing.JFrame;

public class PhysicsLab {
    public static void main(String[] args) {
        MyWorld world = new MyWorld(System.out);
        PhysicsLab_GUI lab_gui = new PhysicsLab_GUI(world);
        lab_gui.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        lab_gui.setVisible(true);

        double mass = 1.0;
        Oscillator os=new Oscillator(new Vector2D( 1,1), new Vector2D(0, 0.25), 0.2);
        Ball b = new Ball(mass, new Vector2D( 2,1), new Vector2D( 0,0));
        b.setColor(Color.RED);
        Spring s = new Spring(1.0, 1.0);
        Dashpot da = new Dashpot(0.4);
        s.attachEnd(os);
        s.attachEnd(b);
        da.attachEnd(b);
        world.addElement(s);
        world.addElement(b);
        world.addElement(os);        
        world.addElement(da);        
        b=new Ball(mass, new Vector2D( 3,1), new Vector2D( 0,0));
        da.attachEnd(b);
        world.addElement(b);
        world.start();
    }
}

class PhysicsLab_GUI extends JFrame {
    public PhysicsLab_GUI(MyWorld world) {
        setTitle("My Small and Nice Physics Laboratory");
        setSize(MyWorldView.WIDTH+100, MyWorldView.HEIGHT+150);
        MyWorldView  worldView = new MyWorldView(world);
        world.setView(worldView);
        getContentPane().add(worldView);  
    }
}