import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class PhysicsLab {
    public static void main(String[] args) {
        MyWorld world = new MyWorld(System.out);
        PhysicsLab_GUI lab_gui = new PhysicsLab_GUI(world);
        lab_gui.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        lab_gui.setVisible(true);
        world.start();
    }
}

class PhysicsLab_GUI extends JFrame implements ActionListener{
    private JMenuBar mb;
    private JMenu menu1;
    private JMenuItem item1,item2;
    MyWorld world = new MyWorld(System.out);
    
    public PhysicsLab_GUI(MyWorld world) {
        mb=new JMenuBar();
        menu1=new JMenu("Insert");
        mb.add(menu1);
        item1=new JMenuItem("Configuration");
        item2=new JMenuItem("Extra Credits");
        item1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,ActionEvent.CTRL_MASK));
        item2.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_2,ActionEvent.CTRL_MASK));
        item1.addActionListener(this);
        item2.addActionListener(this);
        menu1.add(item1);
        menu1.add(item2);
        setJMenuBar(mb);
        setTitle("My Small and Nice Physics Laboratory");
        setSize(MyWorldView.WIDTH+100, MyWorldView.HEIGHT+150);
        this.world=world;
        MyWorldView  worldView = new MyWorldView(this.world);
        world.setView(worldView);
        getContentPane().add(worldView);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if(e.getSource()==item1){
            if(!world.getPhysicsElements().isEmpty())
                world.setPhysicsElements(new ArrayList<PhysicsElement>());
            Attachable at =new Oscillator(new Vector2D(1,1), new Vector2D(0.0, 0.25),0.2);
            Spring s;
            double NP=9,LR=(0.25*10)/(NP+1);
            for(int i=1;i<=NP;i++){
                s=new Spring(LR, 1.0);
                world.addElement(s);
                s.attachEnd(at);
                world.addElement((PhysicsElement)at);
                Attachable at2= new Ball(1, new Vector2D(1+(i*LR), 1), new Vector2D(0, 0));
                s.attachEnd(at2);
                world.addElement((PhysicsElement)at2);
                at=at2;
            }
            Dashpot da=new Dashpot(0.2);
            da.attachEnd(at);
            at=new Oscillator(new Vector2D(1+LR*(NP+1),1), new Vector2D(0.0, -0.5), 0);
            world.addElement((PhysicsElement)at);
            world.addElement(da);
            da.attachEnd(at);
        }
        if(e.getSource()==item2){
            if(!world.getPhysicsElements().isEmpty())
                world.setPhysicsElements(new ArrayList<PhysicsElement>());
            Attachable at =new Oscillator(new Vector2D(1,1), new Vector2D(0.5, 0),0.2);
            world.addElement((PhysicsElement)at);
            Elastic el = new Elastic(1, 1);
            el.attachEnd(at);
            world.addElement(el);
            at= new Ball(1, new Vector2D(2, 1), new Vector2D(0, 0));
            world.addElement((PhysicsElement)at);
            el.attachEnd(at);
        }
    }
}